Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34921)
@@ -2319,6 +1408,7 @@
                             $notIFD = $$oldInfo{NotIFD};
                         } else {
-                            $exifTool->Warn('Internal problem getting maker notes tag table');
-                        }
+                            $et->Warn('Internal problem getting maker notes tag table');
+                        }
+                        $writeProc or $writeProc = $$subTable{WRITE_PROC} if $subTable;
                         $subTable or $subTable = $tagTablePtr;
                         if ($writeProc and
@@ -2329,5 +1419,5 @@
                         } elsif (not $notIFD) {
                             # look for IFD-style maker notes
-                            $loc = Image::ExifTool::MakerNotes::LocateIFD($exifTool,\%subdirInfo);
+                            $loc = Image::ExifTool::MakerNotes::LocateIFD($et,\%subdirInfo);
                         }
                         if (defined $loc) {
@@ -2335,5 +1425,10 @@
                             $subdirInfo{Fixup} = new Image::ExifTool::Fixup;
                             # rewrite maker notes
-                            $subdir = $exifTool->WriteDirectory(\%subdirInfo, $subTable, $writeProc);
+                            my $changed = $$et{CHANGED};
+                            $subdir = $et->WriteDirectory(\%subdirInfo, $subTable, $writeProc);
+                            if ($changed == $$et{CHANGED} and $subdirInfo{Fixup}->IsEmpty()) {
+                                # return original data if nothing changed and no fixups
+                                undef $subdir;
+                            }
                         } elsif ($$subTable{PROCESS_PROC} and
                                  $$subTable{PROCESS_PROC} eq \&Image::ExifTool::ProcessBinaryData)
@@ -2350,15 +1445,20 @@
                             }
                             # rewrite maker notes
-                            $subdir = $exifTool->WriteDirectory(\%subdirInfo, $subTable);
-                        } elsif (not $notIFD) {
+                            $subdir = $et->WriteDirectory(\%subdirInfo, $subTable);
+                        } elsif ($notIFD) {
+                            if ($writeProc) {
+                                $loc = 0;
+                                $subdir = $et->WriteDirectory(\%subdirInfo, $subTable);
+                            }
+                        } else {
                             my $msg = 'Maker notes could not be parsed';
-                            if ($$exifTool{FILE_TYPE} eq 'JPEG') {
-                                $exifTool->Warn($msg, 1);
+                            if ($$et{FILE_TYPE} eq 'JPEG') {
+                                $et->Warn($msg, 1);
                             } else {
-                                $exifTool->Error($msg, 1);
+                                $et->Error($msg, 1);
                             }
                         }
                         if (defined $subdir) {
-                            next unless length $subdir;
+                            length $subdir or SetByteOrder($saveOrder), next;
                             my $valLen = length($valBuff);
                             # restore existing header and substitute the new
@@ -2366,16 +1466,16 @@
                             $newValue = substr($oldValue, 0, $loc) . $subdir;
                             my $makerFixup = $subdirInfo{Fixup};
-                            my $previewInfo = $exifTool->{PREVIEW_INFO};
+                            my $previewInfo = $$et{PREVIEW_INFO};
                             if ($subdirInfo{Relative}) {
                                 # apply a one-time fixup to $loc since offsets are relative
-                                $makerFixup->{Start} += $loc;
+                                $$makerFixup{Start} += $loc;
                                 # shift all offsets to be relative to new base
                                 my $baseShift = $valueDataPos + $valuePtr + $base - $subdirInfo{Base};
-                                $makerFixup->{Shift} += $baseShift;
+                                $$makerFixup{Shift} += $baseShift;
                                 $makerFixup->ApplyFixup(\$newValue);
                                 if ($previewInfo) {
                                     # remove all but PreviewImage fixup (since others shouldn't change)
-                                    foreach (keys %{$makerFixup->{Pointers}}) {
-                                        /_PreviewImage$/ or delete $makerFixup->{Pointers}{$_};
+                                    foreach (keys %{$$makerFixup{Pointers}}) {
+                                        /_PreviewImage$/ or delete $$makerFixup{Pointers}{$_};
                                     }
                                     # zero pointer so we can see how it gets shifted later
@@ -2383,8 +1483,8 @@
                                     # set the pointer to the start of the EXIF information
                                     # add preview image fixup to list of value fixups
-                                    $makerFixup->{Start} += $valLen;
+                                    $$makerFixup{Start} += $valLen;
                                     push @valFixups, $makerFixup;
-                                    $previewInfo->{BaseShift} = $baseShift;
-                                    $previewInfo->{Relative} = 1;
+                                    $$previewInfo{BaseShift} = $baseShift;
+                                    $$previewInfo{Relative} = 1;
                                 }
                             # don't shift anything if relative flag set to zero (Pentax patch)
@@ -2400,20 +1500,20 @@
                                     (not $subdirInfo{MinOffset} or $subdirInfo{MinOffset} + $baseShift < 0))
                                 {
-                                    my $fixBase = $exifTool->Options('FixBase');
+                                    my $fixBase = $et->Options('FixBase');
                                     if (not defined $fixBase) {
-                                        my $str = $exifTool->Options('IgnoreMinorErrors') ? 'ignored' : 'fix or ignore?';
-                                        $exifTool->Error("MakerNotes offsets may be incorrect ($str)", 1);
+                                        my $str = $et->Options('IgnoreMinorErrors') ? 'ignored' : 'fix or ignore?';
+                                        $et->Error("MakerNotes offsets may be incorrect ($str)", 1);
                                     } elsif ($fixBase eq '') {
-                                        $exifTool->Warn('Fixed incorrect MakerNotes offsets');
+                                        $et->Warn('Fixed incorrect MakerNotes offsets');
                                         $baseShift = 0;
                                     }
                                 }
-                                $makerFixup->{Start} += $valLen + $loc;
-                                $makerFixup->{Shift} += $baseShift;
+                                $$makerFixup{Start} += $valLen + $loc;
+                                $$makerFixup{Shift} += $baseShift;
                                 # permanently fix makernote offset errors
-                                $makerFixup->{Shift} += $subdirInfo{FixedBy} || 0;
+                                $$makerFixup{Shift} += $subdirInfo{FixedBy} || 0;
                                 push @valFixups, $makerFixup;
-                                if ($previewInfo and not $previewInfo->{NoBaseShift}) {
-                                    $previewInfo->{BaseShift} = $baseShift;
+                                if ($previewInfo and not $$previewInfo{NoBaseShift}) {
+                                    $$previewInfo{BaseShift} = $baseShift;
                                 }
                             }
@@ -2426,5 +1526,6 @@
                 } elsif ($$newInfo{SubDirectory} and $isNew <= 0 and not $isOverwriting
                     # don't edit directory if Writable is set to 0
-                    and (not defined $$newInfo{Writable} or $$newInfo{Writable}))
+                    and (not defined $$newInfo{Writable} or $$newInfo{Writable}) and
+                    not $$newInfo{ReadFromRAF})
                 {
 
@@ -2439,11 +1540,11 @@
                         }
                         # determine directory name for this IFD
-                        my $subdirName = $newInfo->{Groups}{1} || $$newInfo{Name};
+                        my $subdirName = $$newInfo{Groups}{1} || $$newInfo{Name};
                         # all makernotes directory names must be 'MakerNotes'
-                        $subdirName = 'MakerNotes' if $subTable->{GROUPS}{0} eq 'MakerNotes';
+                        $subdirName = 'MakerNotes' if $$subTable{GROUPS}{0} eq 'MakerNotes';
                         # must handle sub-IFD's specially since the values
                         # are actually offsets to subdirectories
                         unless ($readCount) {   # can't have zero count
-                            return undef if $exifTool->Error("$name entry $index has zero count", 1);
+                            return undef if $et->Error("$name entry $index has zero count", 2);
                             next;
                         }
@@ -2453,8 +1554,20 @@
                         for ($i=0; $i<$readCount; ++$i) {
                             my $off = $i * $formatSize[$readFormat];
-                            my $pt = Image::ExifTool::ReadValue($valueDataPt, $valuePtr + $off,
-                                            $readFormName, 1, $oldSize - $off);
-                            my $subdirStart = $pt - $dataPos;
+                            my $val = ReadValue($valueDataPt, $valuePtr + $off,
+                                                $readFormName, 1, $oldSize - $off);
+                            my $subdirStart = $val - $dataPos;
                             my $subdirBase = $base;
+                            my $hdrLen;
+                            if (defined $$subdir{Start}) {
+                                #### eval Start ($val)
+                                my $newStart = eval $$subdir{Start};
+                                unless (Image::ExifTool::IsInt($newStart)) {
+                                    $et->Error("Bad subdirectory start for $$newInfo{Name}");
+                                    next;
+                                }
+                                $newStart -= $dataPos;
+                                $hdrLen = $newStart - $subdirStart;
+                                $subdirStart = $newStart;
+                            }
                             if ($$subdir{Base}) {
                                 my $start = $subdirStart + $dataPos;
@@ -2496,7 +1609,7 @@
                                 } else {
                                     my @err = ("Can't read $subdirName data", $inMakerNotes);
-                                    if ($$subTable{VARS} and $subTable->{VARS}{MINOR_ERRORS}) {
-                                        $exifTool->Warn($err[0] . '. Ignored.');
-                                    } elsif ($exifTool->Error(@err)) {
+                                    if ($$subTable{VARS} and $$subTable{VARS}{MINOR_ERRORS}) {
+                                        $et->Warn($err[0] . '. Ignored.');
+                                    } elsif ($et->Error(@err)) {
                                         return undef;
                                     }
@@ -2504,9 +1617,14 @@
                                 }
                             }
-                            my $subdirData = $exifTool->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
+                            my $subdirData = $et->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
                             unless (defined $subdirData) {
                                 # WriteDirectory should have issued an error, but check just in case
-                                $exifTool->Error("Error writing $subdirName") unless $$exifTool{VALUE}{Error};
+                                $et->Error("Error writing $subdirName") unless $$et{VALUE}{Error};
                                 return undef;
+                            }
+                            # add back original header if necessary (eg. Ricoh GR)
+                            if ($hdrLen and $hdrLen > 0 and $subdirStart <= $dataLen) {
+                                $subdirData = substr($$dataPt, $subdirStart - $hdrLen, $hdrLen) . $subdirData;
+                                $subdirInfo{Fixup}{Start} += $hdrLen;
                             }
                             unless (length $subdirData) {
@@ -2604,5 +1722,5 @@
                         my $oldOrder = GetByteOrder();
                         SetByteOrder($$subdir{ByteOrder}) if $$subdir{ByteOrder};
-                        $newValue = $exifTool->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
+                        $newValue = $et->WriteDirectory(\%subdirInfo, $subTable, $$subdir{WriteProc});
                         SetByteOrder($oldOrder);
                         if (defined $newValue) {
@@ -2610,11 +1728,9 @@
                             if ($hdrLen) {
                                 $newValue = substr($$valueDataPt, $valuePtr, $hdrLen) . $newValue;
-                                $subFixup->{Start} += $hdrLen;
+                                $$subFixup{Start} += $hdrLen;
                             }
                             $newValuePt = \$newValue;
-                        }
-                        unless (defined $$newValuePt) {
-                            $exifTool->Error("Error writing $dirName:$$newInfo{Name}");
-                            return undef;
+                        } else {
+                            $newValuePt = \$oldValue;
                         }
                         unless (length $$newValuePt) {
@@ -2622,6 +1738,6 @@
                             next if $oldSize or not $inMakerNotes;
                         }
-                        if ($subFixup->{Pointers} and $subdirInfo{Base} == $base) {
-                            $subFixup->{Start} += length $valBuff;
+                        if ($$subFixup{Pointers} and $subdirInfo{Base} == $base) {
+                            $$subFixup{Start} += length $valBuff;
                             push @valFixups, $subFixup;
                         } else {
@@ -2639,9 +1755,9 @@
                         # must decide now if we will write CanonVRD information
                         my $hasVRD;
-                        if ($exifTool->{NEW_VALUE}{$Image::ExifTool::Extra{CanonVRD}}) {
+                        if ($$et{NEW_VALUE}{$Image::ExifTool::Extra{CanonVRD}}) {
                             # adding or deleting as a block
-                            $hasVRD = $exifTool->GetNewValues('CanonVRD') ? 1 : 0;
-                        } elsif ($exifTool->{DEL_GROUP}{CanonVRD} or
-                                 $exifTool->{DEL_GROUP}{Trailer})
+                            $hasVRD = $et->GetNewValue('CanonVRD') ? 1 : 0;
+                        } elsif ($$et{DEL_GROUP}{CanonVRD} or
+                                 $$et{DEL_GROUP}{Trailer})
                         {
                             $hasVRD = 0;    # deleting as a group
@@ -2662,12 +1778,12 @@
                         #   invalidated anyway by our edits
                         my $odd;
-                        my $oddInfo = $Image::ExifTool::Composite{OriginalDecisionData};
-                        if ($oddInfo and $exifTool->{NEW_VALUE}{$oddInfo}) {
-                            $odd = $exifTool->GetNewValues($dataTag);
+                        my $oddInfo = Image::ExifTool::GetCompositeTagInfo('OriginalDecisionData');
+                        if ($oddInfo and $$et{NEW_VALUE}{$oddInfo}) {
+                            $odd = $et->GetNewValue($dataTag);
                             if ($verbose > 1) {
                                 print $out "    - $dirName:$dataTag\n" if $$newValuePt ne "\0\0\0\0";
                                 print $out "    + $dirName:$dataTag\n" if $odd;
                             }
-                            ++$exifTool->{CHANGED};
+                            ++$$et{CHANGED};
                         } elsif ($$newValuePt ne "\0\0\0\0") {
                             if (length($$newValuePt) == 4) {
@@ -2675,9 +1791,9 @@
                                 my $offset = Get32u($newValuePt,0);
                                 # absolute offset in JPEG images only
-                                $offset += $base unless $$exifTool{FILE_TYPE} eq 'JPEG';
-                                $odd = Image::ExifTool::Canon::ReadODD($exifTool, $offset);
+                                $offset += $base unless $$et{FILE_TYPE} eq 'JPEG';
+                                $odd = Image::ExifTool::Canon::ReadODD($et, $offset);
                                 $odd = $$odd if ref $odd;
                             } else {
-                                $exifTool->Error("Invalid $$newInfo{Name}",1);
+                                $et->Error("Invalid $$newInfo{Name}",1);
                             }
                         }
@@ -2685,5 +1801,5 @@
                             my $newOffset = length($valBuff);
                             # (ODD offset is absolute in JPEG, so add base offset!)
-                            $newOffset += $base if $$exifTool{FILE_TYPE} eq 'JPEG';
+                            $newOffset += $base if $$et{FILE_TYPE} eq 'JPEG';
                             $newValue = Set32u($newOffset);
                             $dirFixup->AddFixup(length($dirBuff) + 8, $dataTag);
@@ -2703,4 +1819,5 @@
                             @vals = ReadValue(\$oldValue, 0, $readFormName, $readCount, $oldSize);
                             SetByteOrder($oldOrder);
+                            $validateInfo{$newID} = [$newInfo, join(' ',@vals)] unless $$newInfo{IsOffset};
                         }
                         # only support int32 pointers (for now)
@@ -2716,4 +1833,5 @@
                                 return undef;
                             }
+                            $newValuePt = \$newValue;
                         }
                         $offsetInfo or $offsetInfo = $offsetInfo[$ifd] = { };
@@ -2724,5 +1842,5 @@
                         $newCount or $newCount = 1; # make sure count is set for offsetInfo
                         # save value pointer and value count for each tag
-                        $offsetInfo->{$newID} = [$newInfo, $ptr, $newCount, \@vals, $newFormat];
+                        $$offsetInfo{$newID} = [$newInfo, $ptr, $newCount, \@vals, $newFormat];
                     }
 
@@ -2744,12 +1862,13 @@
                         # let the RawConv store the (possibly converted) data member
                         if (ref $conv eq 'CODE') {
-                            &$conv($val, $exifTool);
+                            &$conv($val, $et);
                         } else {
-                            my ($self, $tag, $taginfo) = ($exifTool, $$newInfo{Name}, $newInfo);
-                            #### eval RawConv ($self, $val, $tag, $tagInfo)
+                            my ($priority, @grps);
+                            my ($self, $tag, $tagInfo) = ($et, $$newInfo{Name}, $newInfo);
+                            #### eval RawConv ($self, $val, $tag, $tagInfo, $priority, @grps)
                             eval $conv;
                         }
                     } else {
-                        $$exifTool{$$newInfo{DataMember}} = $val;
+                        $$et{$$newInfo{DataMember}} = $val;
                     }
                 }
@@ -2761,5 +1880,10 @@
             my $fsize = $formatSize[$newFormat];
             my $offsetVal;
-            $newCount = int(($newSize + $fsize - 1) / $fsize);  # set proper count
+            # set proper count
+            $newCount = int(($newSize + $fsize - 1) / $fsize) unless $oldInfo and $$oldInfo{FixedSize};
+            if ($saveForValidate{$newID} and $tagTablePtr eq \%Image::ExifTool::Exif::Main) {
+                my @vals = ReadValue(\$newValue, 0, $newFormName, $newCount, $newSize);
+                $validateInfo{$newID} = join ' ',@vals;
+            }
             if ($newSize > 4) {
                 # zero-pad to an even number of bytes (required by EXIF standard)
@@ -2779,18 +1903,20 @@
                 ($dataTag, $putFirst) = @$newInfo{'DataTag','PutFirst'} if $newInfo;
                 if ($dataTag) {
-                    if ($dataTag eq 'PreviewImage' and ($exifTool->{FILE_TYPE} eq 'JPEG' or
-                        $$exifTool{GENERATE_PREVIEW_INFO}))
+                    if ($dataTag eq 'PreviewImage' and ($$et{FILE_TYPE} eq 'JPEG' or
+                        $$et{GENERATE_PREVIEW_INFO}))
                     {
                         # hold onto the PreviewImage until we can determine if it fits
-                        $exifTool->{PREVIEW_INFO} or $exifTool->{PREVIEW_INFO} = { };
-                        $exifTool->{PREVIEW_INFO}{Data} = $$newValuePt;
-                        $exifTool->{PREVIEW_INFO}{ChangeBase} = 1 if $$newInfo{ChangeBase};
+                        $$et{PREVIEW_INFO} or $$et{PREVIEW_INFO} = {
+                            Data => $$newValuePt,
+                            Fixup => new Image::ExifTool::Fixup,
+                        };
+                        $$et{PREVIEW_INFO}{ChangeBase} = 1 if $$newInfo{ChangeBase};
                         if ($$newInfo{IsOffset} and $$newInfo{IsOffset} eq '2') {
-                            $exifTool->{PREVIEW_INFO}{NoBaseShift} = 1;
+                            $$et{PREVIEW_INFO}{NoBaseShift} = 1;
                         }
                         # use original preview size if we will attempt to load it later
                         $newCount = $oldCount if $$newValuePt eq 'LOAD_PREVIEW';
                         $$newValuePt = '';
-                    } elsif ($dataTag eq 'LeicaTrailer' and $$exifTool{LeicaTrailer}) {
+                    } elsif ($dataTag eq 'LeicaTrailer' and $$et{LeicaTrailer}) {
                         $$newValuePt = '';
                     }
@@ -2798,5 +1924,5 @@
                 if ($putFirst and $$dirInfo{HeaderPtr}) {
                     my $hdrPtr = $$dirInfo{HeaderPtr};
-                    # place this value immediately after the TIFF header
+                    # place this value immediately after the TIFF header (eg. IIQ maker notes)
                     $offsetVal = Set32u(length $$hdrPtr);
                     $$hdrPtr .= $$newValuePt;
@@ -2834,11 +1960,16 @@
             }
         }
+        if (%validateInfo) {
+            ValidateImageData($et, \%validateInfo, $dirName, 1);
+            undef %validateInfo;
+        }
         if ($ignoreCount) {
             my $y = $ignoreCount > 1 ? 'ies' : 'y';
-            $exifTool->Warn("Removed $ignoreCount invalid entr$y from $name", 1);
+            my $verb = $$dirInfo{FixBase} ? 'Ignored' : 'Removed';
+            $et->Warn("$verb $ignoreCount invalid entr$y from $name", 1);
         }
         if ($fixCount) {
             my $s = $fixCount > 1 ? 's' : '';
-            $exifTool->Warn("Fixed invalid count$s for $fixCount $name tag$s", 1);
+            $et->Warn("Fixed invalid count$s for $fixCount $name tag$s", 1);
         }
 #..............................................................................
@@ -2854,5 +1985,7 @@
         my $isNextIFD = ($$dirInfo{Multi} and ($nextIfdOffset or
                         # account for the case where we will create the next IFD
-                        ($dirName eq 'IFD0' and $exifTool->{ADD_DIRS}{'IFD1'})));
+                        # (IFD1 only, but not in TIFF-format images)
+                        ($dirName eq 'IFD0' and $$et{ADD_DIRS}{'IFD1'} and
+                         $$et{FILE_TYPE} ne 'TIFF')));
         # calculate number of entries in new directory
         my $newEntries = length($dirBuff) / 12;
@@ -2866,5 +1999,5 @@
             ++$deleteAll if defined $deleteAll;
             $verbose > 1 and print $out "    - $allMandatory mandatory tag(s)\n";
-            $exifTool->{CHANGED} -= $addMandatory;    # didn't change these after all
+            $$et{CHANGED} -= $addMandatory;    # didn't change these after all
         }
         if ($ifd and not $newEntries) {
@@ -2874,11 +2007,17 @@
         # apply one-time fixup for entry-based offsets
         if ($entryBasedFixup) {
-            $entryBasedFixup->{Shift} = length($dirBuff) + 4;
+            $$entryBasedFixup{Shift} = length($dirBuff) + 4;
             $entryBasedFixup->ApplyFixup(\$dirBuff);
             undef $entryBasedFixup;
         }
+        # initialize next IFD pointer to zero
+        my $nextIFD = Set32u(0);
+        # some cameras use a different amount of padding after the makernote IFD
+        if ($dirName eq 'MakerNotes' and $$dirInfo{Parent} =~ /^(ExifIFD|IFD0)$/) {
+            my ($rel, $pad) = Image::ExifTool::MakerNotes::GetMakerNoteOffset($et);
+            $nextIFD = "\0" x $pad if defined $pad and ($pad==0 or ($pad>4 and $pad<=32));
+        }
         # add directory entry count to start of IFD and next IFD pointer to end
-        # (temporarily set next IFD pointer to zero)
-        $newData .= Set16u($newEntries) . $dirBuff . Set32u(0);
+        $newData .= Set16u($newEntries) . $dirBuff . $nextIFD;
         # get position of value data in newData
         my $valPos = length($newData);
@@ -2890,5 +2029,5 @@
         }
         # remember position of 'next IFD' pointer so we can set it next time around
-        $nextIfdPos = $valPos - 4;
+        $nextIfdPos = length($nextIFD) ? $valPos - length($nextIFD) : undef;
         # add value data after IFD
         $newData .= $valBuff;
@@ -2930,5 +2069,5 @@
                 # check to be sure we got the right offset
                 unless (Get32u(\$newData, $offset) == 0xfeedf00d) {
-                    $exifTool->Error("Internal error while rewriting $name");
+                    $et->Error("Internal error while rewriting $name");
                     return undef;
                 }
@@ -2941,6 +2080,6 @@
         # (which is at the end of this directory)
         if ($dirFixup) {
-            $dirFixup->{Start} = $newStart + 2;
-            $dirFixup->{Shift} = $valPos - $dirFixup->{Start};
+            $$dirFixup{Start} = $newStart + 2;
+            $$dirFixup{Shift} = $valPos - $$dirFixup{Start};
             $fixup->AddFixup($dirFixup);
         }
@@ -2948,5 +2087,5 @@
         my $valFixup;
         foreach $valFixup (@valFixups) {
-            $valFixup->{Start} += $valPos;
+            $$valFixup{Start} += $valPos;
             $fixup->AddFixup($valFixup);
         }
@@ -2967,30 +2106,32 @@
         my $ifdNum = $dirName =~ s/(\d+)$// ? $1 : 0;
         $dirName .= $ifdNum + 1;
-        $$exifTool{DIR_NAME} = $$exifTool{PATH}[-1] = $dirName;
+        $name =~ s/\d+$//;
+        $name .= $ifdNum + 1;
+        $$et{DIR_NAME} = $$et{PATH}[-1] = $dirName;
         next unless $nextIfdOffset;
 
         # guard against writing the same directory twice
         my $addr = $nextIfdOffset + $base;
-        if ($exifTool->{PROCESSED}{$addr}) {
-            $exifTool->Error("$name pointer references previous $exifTool->{PROCESSED}{$addr} directory", 1);
+        if ($$et{PROCESSED}{$addr}) {
+            $et->Error("$name pointer references previous $$et{PROCESSED}{$addr} directory", 1);
             last;
         }
-        $exifTool->{PROCESSED}{$addr} = $name;
+        $$et{PROCESSED}{$addr} = $name;
 
         if ($dirName eq 'SubIFD1' and not ValidateIFD($dirInfo, $dirStart)) {
-            if ($exifTool->{TIFF_TYPE} eq 'TIFF') {
-                $exifTool->Error('Ignored bad IFD linked from SubIFD', 1);
+            if ($$et{TIFF_TYPE} eq 'TIFF') {
+                $et->Error('Ignored bad IFD linked from SubIFD', 1);
             } elsif ($verbose) {
-                $exifTool->Warn('Ignored bad IFD linked from SubIFD');
+                $et->Warn('Ignored bad IFD linked from SubIFD');
             }
             last;   # don't write bad IFD
         }
-        if ($exifTool->{DEL_GROUP}{$dirName}) {
+        if ($$et{DEL_GROUP}{$dirName}) {
             $verbose and print $out "  Deleting $dirName\n";
-            $raf and $exifTool->Error("Deleting $dirName also deletes subsequent" .
+            $raf and $et->Error("Deleting $dirName also deletes subsequent" .
                                       " IFD's and possibly image data", 1);
-            ++$exifTool->{CHANGED};
-            if ($exifTool->{DEL_GROUP}{$dirName} == 2 and
-                $exifTool->{ADD_DIRS}{$dirName})
+            ++$$et{CHANGED};
+            if ($$et{DEL_GROUP}{$dirName} == 2 and
+                $$et{ADD_DIRS}{$dirName})
             {
                 my $emptyIFD = "\0" x 2;    # start with empty IFD
@@ -3035,5 +2176,5 @@
                     require Image::ExifTool::PanasonicRaw;
                     my $err = Image::ExifTool::PanasonicRaw::PatchRawDataOffset($offsetInfo, $raf, $ifd);
-                    $err and $exifTool->Error($err);
+                    $err and $et->Error($err);
                 }
                 my $tagID;
@@ -3041,8 +2182,8 @@
                 # data before main image data if both exist in the same IFD
                 foreach $tagID (reverse sort keys %$offsetInfo) {
-                    my $tagInfo = $offsetInfo->{$tagID}[0];
+                    my $tagInfo = $$offsetInfo{$tagID}[0];
                     next unless $$tagInfo{IsOffset}; # handle byte counts with offsets
-                    my $sizeInfo = $offsetInfo->{$$tagInfo{OffsetPair}};
-                    $sizeInfo or $exifTool->Error("No size tag for $dirName:$$tagInfo{Name}"), next;
+                    my $sizeInfo = $$offsetInfo{$$tagInfo{OffsetPair}};
+                    $sizeInfo or $et->Error("No size tag for $dirName:$$tagInfo{Name}"), next;
                     my $dataTag = $$tagInfo{DataTag};
                     # write TIFF image data (strips or tiles) later if requested
@@ -3056,7 +2197,7 @@
                         (not defined $dataTag or not defined $offsetData{$dataTag}))
                     {
-                        push @writeLater, [ $offsetInfo->{$tagID}, $sizeInfo ];
+                        push @writeLater, [ $$offsetInfo{$tagID}, $sizeInfo ];
                     } else {
-                        push @offsetList, [ $offsetInfo->{$tagID}, $sizeInfo ];
+                        push @offsetList, [ $$offsetInfo{$tagID}, $sizeInfo ];
                     }
                 }
@@ -3071,5 +2212,5 @@
                 # must be the same number of offset and byte count values
                 unless ($count == $count2) {
-                    $exifTool->Error("Offsets/ByteCounts disagree on count for $$tagInfo{Name}");
+                    $et->Error("Offsets/ByteCounts disagree on count for $$tagInfo{Name}");
                     return undef;
                 }
@@ -3080,5 +2221,5 @@
                 $n > 4 and $byteCounts = Get32u(\$newData, $byteCounts);
                 if ($byteCounts < 0 or $byteCounts + $n > length($newData)) {
-                    $exifTool->Error("Error reading $$tagInfo{Name} byte counts");
+                    $et->Error("Error reading $$tagInfo{Name} byte counts");
                     return undef;
                 }
